# coding=UTF8
# Copyright © 2011 Rob Leachman
# Please see the file COPYING in this distribution for license information
## most of this was Glyph demo code, and/or text from Spoonbill
import pygame
import os
import sys

from _glyph import Main as Glyph
from _glyph import Macros

from pygame import display
from pygame import event
from pygame.font import Font
from pygame import image
from pygame import mouse
from pygame import transform
from pygame.locals import *

import Global


#functions
def center(surf, rect):
# centers rectangles on a specified axis on a surface
    surfrect = surf.get_rect()
    rect.x = ((surfrect.w / 2) - (rect.w / 2))
    rect.y = ((surfrect.h / 2) - (rect.h / 2))


#prepare the pages of text
PAGES = {
    'instructions' : "[Here is a copy of the instruction card which "
"came with the original Serpentine game on the IBM PC. Thanks go to "
"Ian Humphreys of Spoonbill Software for republishing it along with his "
"version, and his man Steve Watkins for supplying this historic gem. "
"The scoring is the same as the Apple version. Edited for color and a "
"couple other tweaks but otherwise just as it was some 25 years ago.]"

"/n/n"

"SERPENTINE (Apple, Atari, Commodore, IBM PC)"
"/n"
"Programmer: David Snider"
"/n"
"Copyright 1982 Broderbund Software"

"/n/n"

"You begin each game with a stable of three tame blue serpents. They can "
"be controlled from the keyboard by use of the directional arrow keys. "
"Your objective is to survive long enough to lay eggs and raise your "
"young. Unfortunately, this is a snake eat snake world, and in order to "
"survive, you will have to avoid or devour the hostile orange serpents "
"that issue from their own chamber in the lower left corner of the maze."

"/n/n"

"Big serpents swallow little serpents - this is a fact of life. So attack "
"the orange serpents from the rear - you are faster than they are, at "
"least when you are young, "
"and can bite off their tail segments until you are "
"longer than they. Once they are shorter than you, they turn green "
"and can be attacked from the front. "
"[Serpentine 2011 includes a new feature -- with perfect timing you can eat "
"an orange enemy by striking at the neck, big fun!]" 

"/n/n"

"Serpent tails are not very nutritious and will not help your serpents "
"grow. However, if they eat a green serpent from the front or catch a "
"frog, your serpents will grow one segment in length. The enemy "
"serpents also love to eat frogs. No serpent will grow longer than "
"seven segments, no matter how much it eats. "

"/n/n"

"All serpents lay eggs. Blue serpents lay lovely white eggs; orange "
"serpents lay ugly speckled eggs. Eggs eventually hatch unless they are "
"eaten first. They are very nutritious - frogs look for them and eat "
"them, as do enemy snakes." # well that's a lie, the enemy snakes don't
# look for eggs and perhaps never will; our eggs hardly last and their eggs
# hatch quickly so... leaving that part out seems better to me!

"/n/n"

"Serpents lose one segment when they lay an egg. If your serpents try "
"to lay an egg when they are only two segments long, they will die in "
"the process, since no self-respecting snake can survive unless it is "
"at least two segments long. " # I coded out the ability to hatch an egg
# and die, it is fun drama but the game is hard enough for most people!

"Once all the enemy snakes are eaten, the white eggs will hatch and "
"return to your stable. A new level will then start with a new maze."

"/n/n"

"SCORING:"

"/n/n"

"Eating a frog scores 500 points and adds one new segment."

"/n/n"

"Eating a spotted egg scores 150 points times the level you are on and "
"adds one new segment."

"/n/n"

"Eating serpents scores 100 points per segment on levels 1 and 2. The "
"score per segment increases by 100 points every other level."

"/n/n"

"Eating serpents head on scores 200 points per segment on levels 1 and 2 "
"and adds a new segment to your serpent. The score per segment increases "
"by 200 points every other level."

"/n/n"

"Extra serpents are awarded for reaching 20,000 points, 50,000 points and "
"every 50,000 points scored thereafter."

"/n/n"

"Press <n> to restart the game, <+> or <-> to adjust speed. "
"Press <p> to pause (and access configuration options), " 
"<esc> twice to quit at any time. "
"For now press <space> to continue."

# These are not supported:
##SPECIAL KEYS: 
##
##s - Toggle sound on/off


,
    'credits' : "The list starts with obvious credit to David Snider "
"and Broderbund for inventing and publishing this game. "
"I had fond memories of it from my "
"misspent youth and believed this would be a fun game to remake."
"/n/n"
"Biggest thanks to Ian Humphreys and his Spoonbill Software, he remade the "
"game for Windows in 1994 and freely offers it (and many others) at " 
"his website (refer to README). "
"Serpentine 2011 uses five of his Magnolia levels with permission. Also he "
"republished the instruction card supplied by Steve Watkins, "
"thank you Steve."
"/n/n"
"My artistic abilities are lacking so I reached out to Samuel Bauman who "
"put together some wonderful looking pixels using Blender. He's talented "
"and will go far. Much appreciated, Samuel!"
"/n/n"
"Eric Porter graciously answered my plea for some decent music with a "
"number of tracks I feel create an excellent mood for the game. His "
"library is vast and very satisfying, check out his website also listed "
"in the README."
"/n/n"
"I found all the sound effects at Freesound.org and comply with the "
"Creative Commons Sampling Plus 1.0 license "
"(once more, see README). Thanks medialint, reinsamba, Anton, pyright one, "
"poots, SGAK and Robinhood76."
"/n/n" 
"The game uses Matthew Welch's White Rabbit font for a nice "
"retro look, and Cafe Nero by justme54s for the bold header and title. "
"Refer to .txt files in the font folder for info and license terms."
"/n/n"
"John Schanck's pyconsole continues to be very handy, as does "
"Scott Barlow's menu class. Josmiley's project ask provided what I needed to "
"accept your high scores and Koen Lefever's Arcade Tonk Tanks gave me a "
"running start at the sound and music routines. " 
"Gummbum's Trolls Outta Luckland is impressive; I only cribbed his "
"code pointing the way to store configs and settings (for now, ha). "
"Thanks for sharing guys, the GPL is a great thing isn't it?"
"/n/n"
"Thank you Chandler Armstrong for the Glyph library (you're "
"soaking in it). So glad to not need to typeset all this text into "
"graphics. "
"And thanks Jima for Cerealizer, we can share awesome demo replays with "
"confidence the files are safe to replay."
"/n/n"
"I guess that will do it. <YOUR NAME HERE> offered, there's plenty left "
"to do and I'm about at the limits of my skills."
"/n/n"
"Others listed in the initial high-scores table:"
"/n/n"
"Guido van Rossum invented Python/n"
"Pete Shinners created (started?) Pygame/n"
"This game would be nothing without the fast path finder by Connelly Barnes/n"
"Mad props to Dr. Bart for setting me straight/n"
"Byron continues to inspire/n"
"My man b0n3b0y provides an excuse/n"
"and Warren and Carter's book 'Hello World!' got me going."
"/n/n"
"Finally, a BIG shout out to the gang at www.pygame.org that maintain the "
"website and keep Pygame moving forward!"
"/n/n"
"--- Rob Leachman, February 2011"
"/n/n"
"Press <esc> twice to quit at any time. For now, <space> to continue."
}

def renderInstructions(screen):
    pathHack = ""
    FONT = Font(os.path.join(pathHack, "fonts", "white_rabbit.ttf"), Global.glyphFontSize)
    DEFAULT = {
        'bkg'       : (0, 0, 0),
        'color'     : (255, 255, 255),
        'font'      : FONT,
        'spacing'   : 0, #FONT.get_linesize(),
        }

    BKGSCREEN = pygame.surface.Surface((Global.screenResolution[0], Global.screenResolution[1]))
    BKGSCREEN.fill((64,64,64))
    
    CLIP = Rect(0, 0, Global.screenResolution[0] - 5, Global.screenResolution[1] - 5)
    center(BKGSCREEN, CLIP)

    BKGSCREEN.set_clip(CLIP)
    BKGSCREEN.fill((1, 1, 1))

    CLIP.w -= 10
    CLIP.h -= 10
    center(BKGSCREEN, CLIP)    
    
    
    glyph = Glyph(CLIP, **DEFAULT)

    glyph_rect = glyph.rect
    glyph.input(PAGES['instructions'], justify = 'left')
    glyph.update()
    screen.blit(BKGSCREEN, (0, 0))
    screen.blit(glyph.image, glyph_rect)


def renderCredits(screen):
    pathHack = ""
    FONT = Font(os.path.join(pathHack, "fonts", "white_rabbit.ttf"), Global.glyphFontSize)
    #FONT = Font(os.path.join(pathHack, "fonts", "VeraSe.ttf"), Global.glyphFontSize)
    DEFAULT = {
        'bkg'       : (0, 0, 0),
        'color'     : (255, 255, 255),
        'font'      : FONT,
        'spacing'   : 0, #FONT.get_linesize(),
        }

    BKGSCREEN = pygame.surface.Surface((Global.screenResolution[0], Global.screenResolution[1]))
    BKGSCREEN.fill((64,64,64))
    
    CLIP = Rect(0, 0, Global.screenResolution[0] - 5, Global.screenResolution[1] - 5)
    center(BKGSCREEN, CLIP)

    BKGSCREEN.set_clip(CLIP)
    BKGSCREEN.fill((1, 1, 1))

    CLIP.w -= 10
    CLIP.h -= 10
    center(BKGSCREEN, CLIP)    
    
    
    glyph = Glyph(CLIP, **DEFAULT)

    glyph_rect = glyph.rect
    glyph.input(PAGES['credits'], justify = 'left')
    glyph.update()
    screen.blit(BKGSCREEN, (0, 0))
    screen.blit(glyph.image, glyph_rect)


class Main():

    def __init__(self):
        self.glyph = Glyph(CLIP, **DEFAULT)


    def start(self):
        glyph = self.glyph
        #start_editor = self.start_editor
        glyph_rect = glyph.rect
        glyph.input(PAGES['0'], justify = 'justified')
        glyph.update()
        SCREEN.blit(BKGSCREEN, (0, 0))
        SCREEN.blit(glyph.image, glyph_rect)
        while 1:
            link = glyph.get_collisions(mouse.get_pos())
            if link: mouse.set_cursor(*HAND_CURSOR)
            else: mouse.set_cursor(*DEFAULT_CURSOR)
            for ev in event.get():
                if ev.type == pygame.QUIT:
                    sys.exit()
                    
                elif ev.type == pygame.KEYDOWN:
                    if (pygame.key.get_mods() == 1024): # command key
                        if (ev.key == 113):   # q
                            sys.exit()
                
                elif ev.type == MOUSEBUTTONDOWN:
                    if link:
                        if link == 'editor': start_editor()
                        else:
                            glyph.clear(SCREEN, BKGSCREEN)
                            glyph.input(PAGES[link], justify = 'left')
                            glyph.update()
                if ev.type == KEYDOWN: pass
            SCREEN.blit(glyph.image, glyph_rect)
            display.update()




if __name__ == '__main__':
    demo = Main()
    demo.start()
