# coding=UTF8
# Copyright © 2011 Rob Leachman
# Please see the file COPYING in this distribution for license information
import os
import pygame

import Global
from MazeWallSprite import MazeWallSprite
from SpotSprite import SpotSprite
import MenuClass
import GlyphText
import Scores
import Title


def render_maze(screen, maze, intersectionMap, level, spriteSheet):
    vertImage = pygame.Surface((Global.postSize, Global.snakeSize * 2 - Global.wallWidth), pygame.SRCALPHA, 32)
    horzImage = pygame.Surface((Global.snakeSize * 2 - Global.wallWidth, Global.postSize), pygame.SRCALPHA, 32)
    postImage = []
    for x in range (4):
        for y in range(4):
            p = pygame.Surface((Global.postSize, Global.postSize), pygame.SRCALPHA, 32)
            postImage.append(p)
    wallSet = (level - 1) % 6
    wallSetX = wallSet * 150
    if Global.res == 0:
        wallSetY = 0
    elif Global.res == 2:
        wallSetY = 100
    else:
        wallSetY = 250
    # Argh this is so wrong! But easier than reworking the sprites right now.
    horzImage.blit(spriteSheet, (0, 0), (wallSetX + Global.postSize + 1, wallSetY, Global.postSize, Global.postSize))
    horzImage.blit(spriteSheet, (Global.postSize, 0), (wallSetX + Global.postSize + 1, wallSetY, horzImage.get_width() - Global.postSize, horzImage.get_height()))
    vertImage.blit(spriteSheet, (0, 0), (wallSetX + Global.postSize * 3 + 3, wallSetY + Global.postSize + 1, Global.postSize, Global.postSize))
    vertImage.blit(spriteSheet, (0, Global.postSize), (wallSetX + Global.postSize * 3 + 3, wallSetY + Global.postSize + 1, vertImage.get_width(), vertImage.get_height() - Global.postSize))
    if Global.res == 0:
        demunge = 2
    elif Global.res == 2:
        demunge = 5
    else:
        demunge = 7
    demunger = pygame.surface.Surface([demunge, Global.postSize])
    demunger.fill((0,0,0))
    horzImage.blit(demunger, (0, 0), (0, 0, demunger.get_width(), demunger.get_height()))
    horzImage.blit(demunger, (horzImage.get_width() - demunger.get_width(), 0), (0, 0, demunger.get_width(), demunger.get_height()))
    demunger = pygame.surface.Surface([Global.postSize, demunge])
    demunger.fill((0,0,0))
    vertImage.blit(demunger, (0, 0), (0, 0, demunger.get_width(), demunger.get_height()))
    vertImage.blit(demunger, (0, vertImage.get_height() - demunger.get_height()), (0, 0, demunger.get_width(), demunger.get_height()))        

    p = 0
    for x in range (4):
        for y in range(4):
            postImage[p].blit(spriteSheet, (0, 0), (wallSetX + Global.postSize * x + x, wallSetY + Global.postSize * y + y, Global.postSize, Global.postSize))
            p += 1
    for x in range (13):
        for y in range (12):
            if maze.getHorizontal(x,y) > 0:
                wall = MazeWallSprite([x,y], "horizontal", (255,0,0), Global.postSize, wallImage = horzImage)
                wall.paint(screen, Global.wallWidth)
    for y in range (11):                
        for x in range (14):
            if maze.getVertical(x,y) > 0:
                wall = MazeWallSprite([x,y], "vertical", (0,255,0), Global.postSize, wallImage = vertImage)
                wall.paint(screen, Global.wallWidth)        
    for x in range (14):
        for y in range (12):
            spotNumber = -1
            if intersectionMap[x][y][0] > 0: # if top
                if intersectionMap[x][y][1] > 0: # if bottom
                    if intersectionMap[x][y][2] > 0: # if right                       
                        if intersectionMap[x][y][3] > 0: # if left
                            spotNumber = 6 # X
                        else:
                            spotNumber = 2 # LT
                    else:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 10 # RT
                        else:
                            spotNumber = 13 # H
                else:
                    if intersectionMap[x][y][2] > 0:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 5 # UT
                        else:
                            spotNumber = 1 # UL
                    else:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 9 # UR
                        else:
                            spotNumber = 12 # U
            else:
                if intersectionMap[x][y][1] > 0:
                    if intersectionMap[x][y][2] > 0:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 7 # BT
                        else:
                            spotNumber = 3 # BL
                    else:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 11 # BR
                        else:
                            spotNumber = 14 # D
                else:
                    if intersectionMap[x][y][2] > 0:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 4 # H
                        else:
                            spotNumber = 0 # L
                    else:
                        if intersectionMap[x][y][3] > 0:
                            spotNumber = 8 # R
            if spotNumber > -1:
                spot = SpotSprite([x, y], Global.postSize, (0,0,255), postImage[spotNumber])
                spot.paint(screen) 


def render_graph(screen, graph):
    """ For debugging only """
    # Needs to be adjusted before use, seems doesn't align at the moment
    for x in range (13):
        for y in range(11):
            nodeX = x * Global.cellSize + Global.offsetX 
            nodeY = y * Global.cellSize + Global.offsetY
            if graph.has_key((x, y)):
                node = graph[x, y]
                #print "Node:", x, y, node
                if not node.has_key((x-1, y)):
                    #print "need west"
                    pygame.draw.lines(screen, (255,255,255), False, [[nodeX-Global.snakeSize,nodeY-Global.wallSize],[nodeX-Global.snakeSize,nodeY+Global.wallSize]],Global.wallWidth)
                if not node.has_key((x+1, y)):
                    #print "need east"
                    pygame.draw.lines(screen, (255,255,255), False, [[nodeX+Global.snakeSize,nodeY-Global.wallSize],[nodeX+Global.snakeSize,nodeY+Global.wallSize]],Global.wallWidth)
                if not node.has_key((x, y-1)):
                    #print "need north"
                    pygame.draw.lines(screen, (255,255,255), False, [[nodeX-Global.wallSize,nodeY-Global.snakeSize],[nodeX+Global.wallSize,nodeY-Global.snakeSize]],Global.wallWidth)
                if not node.has_key((x, y+1)):
                    #print "need south"
                    pygame.draw.lines(screen, (255,255,255), False, [[nodeX-Global.wallSize,nodeY+Global.snakeSize],[nodeX+Global.wallSize,nodeY+Global.snakeSize]],Global.wallWidth)
            else:
                pygame.draw.lines(screen, (255,255,255), False, [[nodeX+Global.snakeSize,nodeY-Global.wallSize],[nodeX+Global.snakeSize,nodeY+Global.wallSize]],Global.wallWidth)
                pygame.draw.lines(screen, (255,255,255), False, [[nodeX-Global.snakeSize,nodeY-Global.wallSize],[nodeX-Global.snakeSize,nodeY+Global.wallSize]],Global.wallWidth)
                pygame.draw.lines(screen, (255,255,255), False, [[nodeX-Global.wallSize,nodeY-Global.snakeSize],[nodeX+Global.wallSize,nodeY-Global.snakeSize]],Global.wallWidth)
                pygame.draw.lines(screen, (255,255,255), False, [[nodeX-Global.wallSize,nodeY+Global.snakeSize],[nodeX+Global.wallSize,nodeY+Global.snakeSize]],Global.wallWidth)


def select_resolution(screen, fullscreen, newResolution):
    screen.fill((0,0,0)) # love the black screen
    if fullscreen:
        fsMode = 'Set Windowed Mode'
    else:
        fsMode = 'Set Fullscreen Mode'
    restartResume = 'Restart game with new settings'
    menu = MenuClass.cMenu(50, 50, 20, 5, 'vertical', 100, screen,
               [(fsMode, 1, None),
                ('640 x 480', 2, None),
                ('800 x 600',  3, None),
                ('1024 x 768', 4, None),
                ('1280 x 960', 5, None),
                (restartResume, 6, None),
                ('Cancel - resume this game', 7, None)])
    if not Global.productionMode:
        print "DEBUG: menu init complete"

    fontFile = os.path.join("fonts", "white_rabbit.ttf")
    font = pygame.font.Font(fontFile, 30)
    menu.set_font(font)
                
    menu.set_center(True, True)
    menu.set_alignment('center', 'center')
    state = 0
    prev_state = 1
    rect_list = []
    
    rezSelected = "unchosen"
    # Menu loop
    while rezSelected == "unchosen":
        # Check if the state has changed, if it has, then post a user event to
        # the queue to force the menu to be shown at least once
        if prev_state != state:
            pygame.event.post(pygame.event.Event(MenuClass.EVENT_CHANGE_STATE, key = 0))
            prev_state = state
            font = pygame.font.Font(fontFile, Global.glyphFontSize)
            instruction_text = font.render("Select resolution (up/down arrows and enter, or mouse)", 1, (255,255,255))
            screen.blit(instruction_text, [10,10])
            pygame.display.flip()
        # Get the next event
        e = pygame.event.wait()
        # Update the menu, based on which "state" we are in - When using the menu
        # in a more complex program, definitely make the states global variables
        # so that you can refer to them by a name
        if (e.type == pygame.KEYDOWN or 
            e.type == MenuClass.EVENT_CHANGE_STATE or 
            e.type == pygame.MOUSEBUTTONUP or 
            pygame.MOUSEBUTTONDOWN or 
            e.type == pygame.MOUSEMOTION):
         if state == 0:
            menu.redraw_all()
            rect_list, state = menu.update(e, state, True)
         elif state == 1:
            rezSelected = "setWindowMode"
            if fullscreen:
                fullscreen = False
            else:
                fullscreen = True
            screen = set_screen_mode(fullscreen)
            state = 0            
         elif state == 2:
            rezSelected = "640x480"
            # Bah, need 2 codes for selected res, it's a mess!
            newResolution = 0
            state = 0
         elif state == 3:
            rezSelected = "800x600"
            newResolution = 2
            state = 0
         elif state == 4:
            rezSelected = "1024x768"
            newResolution = 3
            state = 0
         elif state == 5:
            rezSelected = "1280x960"
            newResolution = 1
            state = 0
         elif state == 6:
            rezSelected = "ready"
            state = 0
         elif state == 7:
            rezSelected = "cancel"
            newResolution = -1
            state = 0
         else:
            print 'never-never land'
            pygame.quit()
            sys.exit()
        # Quit if the user presses the exit button
        if e.type == pygame.QUIT:
         pygame.quit()
         sys.exit()
        # Update the screen
        pygame.display.update(rect_list)
    return (screen, fullscreen, rezSelected, newResolution)

# http://stackoverflow.com/questions/168409/how-do-you-get-a-directory-listing-sorted-by-creation-date-in-python                                
# (efontis)
def getfiles(dirpath):
    try:
        a = [s for s in os.listdir(dirpath)
             if os.path.isfile(os.path.join(dirpath, s))]
        a.sort(key=lambda s: os.path.getmtime(os.path.join(dirpath, s)), reverse=True)
        return a
    except OSError:
        return None


def select_replay(screen, demoDirectory):
    screen.fill((0,0,0)) # love the black screen
    files = getfiles(demoDirectory)
    if files is None:
        return
    choices = []
    menuItem = ("cancel, return to game", 1, None)
    choices.append(menuItem)
    i = 2
    for fname in files:
        if fname != ".DS_Store": # love the Mac! should select only *.demo
            menuItem = (fname, i, None)
            choices.append(menuItem)
            i += 1
            if i > 102:
                break
    menu = MenuClass.cMenu(50, 50, 10, 0, 'vertical', 34, screen, choices)
    fontFile = os.path.join("fonts", "white_rabbit.ttf")
    font = pygame.font.Font(fontFile, Global.glyphFontSize)
    menu.set_font(font)
    menu.set_center(True, True)
    menu.set_alignment('center', 'center')
    state = 0
    prev_state = 1
    rect_list = []
    # Refer to select_resolution for Scott's comments about how this works
    selectedReplay = "unchosen"
    while selectedReplay == "unchosen":
        if prev_state != state:
            pygame.event.post(pygame.event.Event(MenuClass.EVENT_CHANGE_STATE, key = 0))
            prev_state = state
            instruction_text = font.render("Select a level to replay (arrows and enter, or mouse)", 1, (255,255,255))
            screen.blit(instruction_text, [5,5])
            pygame.display.flip()
        e = pygame.event.wait()
        if (e.type == pygame.KEYDOWN or 
            e.type == MenuClass.EVENT_CHANGE_STATE or 
            e.type == pygame.MOUSEBUTTONUP or 
            pygame.MOUSEBUTTONDOWN or 
            e.type == pygame.MOUSEMOTION):
         if state == 0:
            menu.redraw_all()
            rect_list, state = menu.update(e, state, False)
         elif state == 1:
            selectedReplay = "cancelled"
            state = 0            
         else:
            selectedReplay = choices[state-1][0]
        if e.type == pygame.QUIT:
         pygame.quit()
         sys.exit()
        pygame.display.update(rect_list)
    return selectedReplay


def do_instructions(screen):
    GlyphText.renderInstructions(screen)
    pygame.display.flip() 
    Scores.wait_quit_or_continue()


def do_credits(screen):
    GlyphText.renderCredits(screen)
    pygame.display.flip() 
    Scores.wait_quit_or_continue()


def set_screen_mode(fullscreen):
    if fullscreen:
        screenrect = pygame.Rect(0, 0, Global.screenResolution[0], Global.screenResolution[1]) 
        bestdepth = pygame.display.mode_ok(screenrect.size, pygame.FULLSCREEN, 32)
        screen = pygame.display.set_mode(screenrect.size, pygame.FULLSCREEN, bestdepth) 
    else:
        # For demo movies:
        #screen = pygame.display.set_mode(Global.screenResolution, pygame.NOFRAME)
        screen = pygame.display.set_mode(Global.screenResolution)
    return screen


def title_page(screen):
    Title.run(screen, "title.png", True)
#Far in the future, large serpents rule the globe. The serpent kingdom is divided, naturally enough, into good and evil. The good snakes are blue and the evil serpents are a sickly orange. You have managed to tame a few of the blue snakes and now, astride your reptilian mount, you set out to rid the world of evil.
#The game area is, appropriately enough, the streets of an ancient city, now reduced to a series of burnt out corridors...
#David H. Ahl and Chris Vogeli
#Creative Computing Video & Arcade Games, Fall 1983
#As reported at http://www.atarimagazines.com/cva/v1n2/apple2games.php   


def write_fps(screen, framesPerSecond):
    # I was too tired that day I did this... and now compounding the hacks
    clearText = "          "
    fontFile = os.path.join("fonts", "white_rabbit.ttf")
    font = pygame.font.Font(fontFile, Global.bottomFontSize)
    textOut = font.render(clearText, 1, (255,255,255), (0,0,0))
    if Global.res != 3:
        rightX = Global.screenResolution[0] - textOut.get_width()
        fixRes3 = 1
    else:
        rightX = 0
        fixRes3 = 2
    screen.blit(textOut, [rightX, Global.screenResolution[1] - (textOut.get_height()) * fixRes3 ])
    text = " FPS: " + str(int(framesPerSecond)) + " "
    fontFile = os.path.join("fonts", "white_rabbit.ttf")
    font = pygame.font.Font(fontFile, Global.bottomFontSize)
    textOut = font.render(text, 1, (255,255,255))
    if Global.res != 3:
        rightX = Global.screenResolution[0] - textOut.get_width()
    else:
        rightX = 0
    screen.blit(textOut, [rightX, Global.screenResolution[1] - (textOut.get_height()) * fixRes3 ])


def write_headers(screen, level, demo):
    pygame.draw.rect(screen, (0,0,0), [0,0,Global.screenResolution[0], Global.clearScoreHeight], 0)
    if Global.res != 3:
        text = "SERPENTINE 2011"
        fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
        font = pygame.font.Font(fontFile, Global.topFontSize)
        textOut = font.render(text, 1, (255,255,255))
        screen.blit(textOut, [0, 0])
    else:
        # It can be shoehorned in, therefore it must be
        text = "SERPENTINE"
        fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
        font = pygame.font.Font(fontFile, Global.topFontSize)
        textOut1 = font.render(text, 1, (255,255,255))
        screen.blit(textOut1, [0, 0])

        text = "2011"
        textOut = font.render(text, 1, (255,255,255))
        screen.blit(textOut, [int((textOut1.get_width() - textOut.get_width()) / 2), textOut1.get_height()+1])
    if demo:
        text = "DEMO"
    else:
        text = "LEVEL " + str(level)
    textOut = font.render(text, 1, (255,255,255))
    quickBlank = font.render("                        ", 1, (255,255,255), (0,0,0))
    if Global.res != 3:
        centerX = int((Global.screenResolution[0] - textOut.get_width()) / 2)
        screen.blit(textOut, [centerX, 0])
    else:
        screen.blit(quickBlank, ((124 - quickBlank.get_width()) / 2, 50))
        screen.blit(textOut, ((124 - textOut.get_width()) / 2, 50))


def write_footers(screen, highestScore, limitFrames, frameRecord):
    text = " High score: " + str(highestScore)
    fontFile = os.path.join("fonts", "white_rabbit.ttf")
    font = pygame.font.Font(fontFile, Global.bottomFontSize)
    textOut = font.render(text, 1, (255,255,255))
    centerX = int((Global.screenResolution[0] - textOut.get_width()) / 2)
    screen.blit(textOut, [0, Global.screenResolution[1] - textOut.get_height()])
    if limitFrames > 0:
        text = "<esc> to abort else wait a few seconds"
    else:
        if frameRecord is not None:
            text = "Replay: <left> or <right> to speed up/slow down, <down arrow> to end, <p> to pause/quit"
        else:
            text = "Arrows to move. <p> to pause/quit, set graphics and sound, view instructions, etc."
    textOut = font.render(text, 1, (255,255,255), (0,0,0))
    centerX = int((Global.screenResolution[0] - textOut.get_width()) / 2)
    Y = Global.screenResolution[1] - (textOut.get_height() * 2)
    if Global.res == 0:
        Y = Global.screenResolution[1] - (textOut.get_height() * 3)
    elif Global.res == 1:
        Y = Global.screenResolution[1] - (textOut.get_height() * 4)
    elif Global.res == 3:
        centerX = int((Global.screenResolution[0] - textOut.get_width() - 125) / 2) + 125
        Y = Global.screenResolution[1] - (textOut.get_height())
    screen.blit(textOut, [centerX, Y])        


def write_life_count(screen, lives):
    (lifeCountX, lifeCountY, lifeCountBoxSize) = clear_life_count(screen)
    fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
    lifeCountFontSize = Global.topFontSize
    if Global.res == 0:
        lifeCountFontSize = 10
    elif Global.res == 1 or Global.res == 3:
        lifeCountFontSize = 25
    font = pygame.font.Font(fontFile, lifeCountFontSize)
    text = str(lives-1) # we display *extra* lives
    textOut = font.render(text, 1, (255,255,255), (0,0,0))
    lifeCountOutXoffset = int((lifeCountBoxSize - textOut.get_width()) / 2)
    lifeCountOutYoffset = int((lifeCountBoxSize - textOut.get_height()) / 2)
    screen.blit(textOut, [lifeCountX + lifeCountOutXoffset, lifeCountY + lifeCountOutYoffset])


def clear_life_count(screen):
    lifeCountX = int(10*Global.cellSize+Global.offsetX+Global.fudgeX) - int(Global.cellSize * .25) 
    lifeCountY = int(10*Global.cellSize+Global.offsetY+Global.fudgeY) - int(Global.cellSize * .25)
    lifeCountBoxSize = int(Global.cellSize*.5)
    pygame.draw.rect(screen, (0,0,0), [lifeCountX, lifeCountY, lifeCountBoxSize, lifeCountBoxSize], 0)  
    return (lifeCountX, lifeCountY, lifeCountBoxSize)


def write_score(screen, score, demo):
    # Better than a bunch of tests in the main
    if demo:
        return
    if Global.res != 3:
        pygame.draw.rect(screen, 
                         (0,0,0), 
                         [Global.clearScoreLeft,
                          0,
                          Global.screenResolution[0]-Global.clearScoreLeft, 
                          Global.clearScoreHeight], 
                         0
                        )
        text = "SCORE " + str(score)
        fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
        font = pygame.font.Font(fontFile, Global.topFontSize)
        textOut = font.render(text, 1, (255,255,255))
        rightX = Global.screenResolution[0] - textOut.get_width()
        screen.blit(textOut, [rightX, 0])
    else:
        # now I'm rethinking this madness, ha
        if score < 1999:
            pygame.draw.rect(screen, (0,0,0), (0,90,122,14), 0)
            text = "SCORE " + str(score)
            fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
            font = pygame.font.Font(fontFile, Global.topFontSize)
            textOut = font.render(text, 1, (255,255,255))
            screen.blit(textOut, (0, 90))
        else:
            pygame.draw.rect(screen, (0,0,0), (0,90,122,14), 0)
            pygame.draw.rect(screen, (0,0,0), (0,105,122,14), 0)
            text = " SCORE"
            fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
            font = pygame.font.Font(fontFile, Global.topFontSize)
            textOut = font.render(text, 1, (255,255,255))
            rightX = Global.screenResolution[0] - textOut.get_width()
            screen.blit(textOut, (0, 90))
            text = " " + str(score)
            textOut = font.render(text, 1, (255,255,255), (0,0,0))
            rightX = Global.screenResolution[0] - textOut.get_width()
            screen.blit(textOut, (0, 105))


def write_tuning_text(screen):
    text = "Calculating and tuning,"
    fontFile = os.path.join("fonts", "cafe_nero_m54.ttf")
    font = pygame.font.Font(fontFile, Global.topFontSize)
    textOut = font.render(text, 1, (255,255,255))
    centerX = int((Global.screenResolution[0] - textOut.get_width()) / 2)
    screen.blit(textOut, [centerX, Global.topFontSize * 6])
    text = "one moment please..."
    textOut = font.render(text, 1, (255,255,255))
    centerX = int((Global.screenResolution[0] - textOut.get_width()) / 2)
    screen.blit(textOut, [centerX, Global.topFontSize * 8])


def mask_exit_paths(screen, drawnMaze):
    maskX = int(-.5*Global.cellSize+Global.offsetX+Global.fudgeX)
    maskY = Global.mazeBottom
    maskRect = pygame.Rect(maskX, maskY, int(Global.cellSize*1.05), int(Global.cellSize))
    screen.blit(drawnMaze, maskRect, maskRect)
    maskX = int(9.5*Global.cellSize+Global.offsetX+Global.fudgeX)
    maskY = Global.mazeBottom
    maskRect = pygame.Rect(maskX, maskY, int(Global.cellSize*1.05), int(Global.cellSize*2))
    screen.blit(drawnMaze, maskRect, maskRect)
    #pygame.draw.rect(screen, [255,255,0], maskRect, 1)
