# coding=UTF8
# Copyright © 2011 Rob Leachman
# Please see the file COPYING in this distribution for license information
import sys
import pickle
import pygame
from pygame.color import THECOLORS
from pygame.locals import *

import Global

class MapSprite(pygame.sprite.Sprite):
    def __init__(self, location, size, color, mapImage=None):
        pygame.sprite.Sprite.__init__(self)
        if mapImage is None:
            image_surface = pygame.surface.Surface(size)
            image_surface.fill(color)
            self.image = image_surface.convert()
        else:
            self.image = mapImage
            
        self.rect = self.image.get_rect()
        self.rect.left, self.rect.top = (location[0] * Global.cellSize, (location[1]+1) * Global.cellSize)
        
    def paint(self, screen, offset=[0,0]):
        #print "offsetX", offset[0], "Y", offset[1]
        return screen.blit(self.image, [self.rect.left + Global.mapOffsetX + offset[0], self.rect.top + Global.mapOffsetY + offset[1]])
        
if __name__ == '__main__':

    
    
    pygame.init()
    screen = pygame.display.set_mode([800,600])
    
    m = MapSprite([0,0], [Global.cellSize,Global.cellSize], (255,255,255) )  
    m.paint(screen)
    
    m2 = MapSprite([0,0], [5,5], (255,0,0) )
    m2.paint(screen)
    
    m3 = MapSprite([1,1], [5,5], (255,0,0) )
    m3.paint(screen)
    m3A = MapSprite([2,1], [5,5], (255,0,0) )
    m3A.paint(screen)
    m3B = MapSprite([1,1], [Global.cellSize-5,5], (0,0,255) )
    m3B.paint(screen, [5,0])

    m4B = MapSprite([1,2], [Global.cellSize-5,5], (0,0,255) )
    m4B.paint(screen, [5,0])
    m4 = MapSprite([1,2], [5,5], (255,0,0) )
    m4.paint(screen)
        
    
    
    while True:    
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                sys.exit()
            if event.type == pygame.KEYDOWN:
                if (pygame.key.get_mods() == 1024): # command key
                    if (event.key == 113):   # q
                        sys.exit()
                        
        pygame.display.flip()                                                          