# coding=UTF8
# Copyright © 2011 Rob Leachman
# Please see the file COPYING in this distribution for license information
import sys
import pygame

import Global
from MapSprite import MapSprite

class SpotSprite(MapSprite):
    def __init__(self, location, spotSize=3, color=(128,128,128), spotImage = None):
        MapSprite.__init__(self, location, [spotSize, spotSize], color, spotImage)
        
        # Need a shim to keep these centered
        shim = int((Global.wallWidth - spotSize) / 2)
        #print "spot shim", shim
        self.rect.left += shim
        self.rect.top += shim
        self.orientation = "spot"
    
    def paint(self, screen):
        MapSprite.paint(self, screen)


# I broke the test and don't need it anymore
##if __name__ == '__main__':
##    pygame.init()
##    screen = pygame.display.set_mode(Global.screenResolution)
##    s = SpotSprite([0,0], 3)           
##    s.paint(screen)
##    
##    s = SpotSprite([1,1], 9)
##    s.paint(screen)
##    
##    while True:    
##        for event in pygame.event.get():
##            if event.type == pygame.QUIT:
##                sys.exit()
##            if event.type == pygame.KEYDOWN:
##                if (pygame.key.get_mods() == 1024): # command key
##                    if (event.key == 113):   # q
##                        sys.exit()
##        pygame.display.flip()
