# coding=UTF8
# Copyright © 2011 Rob Leachman
# Please see the file COPYING in this distribution for license information
## Was Color Tower Defense - Menu_Mad_Cloud_Games.py, still mostly is?

import pygame
import sys
import os
from pygame.locals import *

import Global

def run(screen, imageFile, requireKeyToContinue):
    
    titleImage = pygame.image.load(os.path.join("graphics", "title.png")).convert()
  

    width = Global.screenResolution[0]
    height = Global.screenResolution[1]
    res = (width, height)
    #screen = pygame.display.set_mode(res)
    cover = pygame.Surface(screen.get_size())
    cover.fill((0,0,0))
    cover_alpha = 255
    alpha_speed = 4
    clock = pygame.time.Clock()
    fps = 30
    TIMER = (4 * fps) # runs for four seconds? not anymore...
    timer = TIMER


    class Title(pygame.sprite.Sprite):

        def __init__(self):
            pygame.sprite.Sprite.__init__(self)
            self.image = pygame.image.load(os.path.join("graphics",imageFile)).convert()
            if Global.screenResolution[0] <> 1280:
                self.image = pygame.transform.scale(self.image, 
                        (Global.screenResolution[0], Global.screenResolution[1]))              
            self.rect = self.image.get_rect()
            self.rect.center = (width/2, height/2)

    logo = Title()
    infoSprites = pygame.sprite.Group(logo)
    running = True
    quitEarly = False
    readyToExit = not requireKeyToContinue
    while running:
        for event in pygame.event.get():
            
            if event.type == pygame.MOUSEBUTTONDOWN:
                quitEarly = True
            elif event.type == pygame.KEYDOWN:
                quitEarly = True
            elif event.type == pygame.QUIT:
                sys.exit()                
                
        if quitEarly:
            screen.fill((0,0,0))
            running = False
                
        if running:
            clock.tick(fps)

            timer -= 1
            if timer >= 0:
                cover_alpha -= alpha_speed # make the cover more transparent
                
            elif timer <= 0 and readyToExit: # more covered
                cover_alpha += alpha_speed
                if cover_alpha >= 255:
                    timer = TIMER
                    running = False

            screen.fill((0,0,0))
            infoSprites.update()
            infoSprites.draw(screen)
            
            cover.set_alpha(cover_alpha)
            screen.blit(cover,(0,0))

        pygame.display.flip()
